%define tcname			tomcat4 	
%define manualtc 		tomcat-4.0
%define manualapi 		servletapi-2.3
%define homedir  		/var/tomcat4
%define javalibdir      /usr/share/java

# RH 7.0
#%%define manualdir		/var/www/html/manual/%{name}
# RH 6.x
%define manualdir		/home/httpd/html/manual/%{name}

%define confdir  		%{homedir}/conf
%define appdir   		%{homedir}/webapps
%define workdir  		%{homedir}/work
%define logdir   		%{homedir}/logs
%define libdir   		%{homedir}/lib
%define srvdir			%{homedir}/server
%define bxxdir			%{homedir}/bin
%define bindir   		/usr/bin
%define packname 		jakarta-tomcat-4.0-m4
%define spackname 		jakarta-servletapi-4.0-m4
%define apackname 		jakarta-ant

Summary: 			Apache's servlet engine
Name: 				%{tcname}
Version: 			4.0
Release: 			m4.1
Vendor: 			Apache Software Foundation
Group: 				Networking/Daemons
Copyright: 			Apache
Url: 				http://jakarta.apache.org
BuildArch: 			noarch
Source: 			http://jakarta.apache.org/builds/tomcat/release/v%{version}/src/%{packname}-src.tar.gz
Source1: 			http://jakarta.apache.org/builds/tomcat/release/v%{version}/src/%{spackname}-src.tar.gz
Source2:			http://jakarta.apache.org/builds/ant/%{apackname}-src-2000-10-19.tar.gz
Source4:			jmxri.jar
Source5: 			TOMCAT4.README.RPM
Source6: 			tomcat4.init
Source7: 			tomcat4.logrotate
Source8:			jaxp-1.0.tar.gz
Source9:			jaxp-1.1.tar.gz
Patch:				tomcat-4.0m4.patch
Packager: 			Henri Gomez <hgomez@slib.fr>
BuildRoot: 			/var/tmp/%{name}-root
BuildRequires:		xerces-j, regexp
Requires:			xerces-j, regexp

%description
Develop Web applications in Java.

%package manual
Group: 		Documentation
Requires: 	webserver
Summary: 	Online manual for tomcat
Obsoletes:	tomcat4-doc

%description manual
Documentation for tomcat

%prep
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}

%setup -c -T -a 0
%setup -T -D -a 1
%setup -T -D -a 2
%patch

%build
cp %{SOURCE4} .
# install JAXP 1.0
tar xvzf %{SOURCE8}
# install JAXP 1.1
tar xvzf %{SOURCE9}
export TCRPMDIR=$RPM_BUILD_DIR/%{name}-%{version}
export CLASSPATH=$TCRPMDIR/jmxri.jar:%{javalibdir}/jcert.jar:%{javalibdir}/jnet.jar:%{javalibdir}/jsse.jar:%{javalibdir}/xerces.jar:%{javalibdir}/xalan.jar:%{javalibdir}/jakarta-regexp-1.1.jar:$TCRPMDIR/dist/servletapi/lib/servlet.jar:$TCRPMDIR/build/tomcat-4.0/classes:$JAVA_HOME/lib/tools.jar:$CLASSPATH

if [ -f /usr/bin/jikes ]; then
	export CLASSPATH=$CLASSPATH:$JAVA_HOME/jre/lib/rt.jar
	export JAVAC=jikes
	export ANT_OPTS=-Dbuild.compiler=jikes
fi

cd %{apackname}
sh bootstrap.sh
sh build.sh dist

cd ../%{spackname}-src
export ANT_HOME=$TCRPMDIR/build/ant
sh $ANT_HOME/bin/ant clean
sh $ANT_HOME/bin/ant dist

cd ../%{packname}-src
export ANT_OPTS="$ANT_OPTS -Dcatalina.jaxp.home=$TCRPMDIR/jaxp-1.0/ -Dcatalina.jaxp.parser.jar=parser.jar  -Djasper.jaxp.home=$TCRPMDIR/jaxp-1.1/ -Djasper.jaxp.parser.jar=crimson.jar -Djmxri.jar=$TCRPMDIR/jmxri.jar -Djcert.jar=%{javalibdir}/jcert.jar -Djnet.jar=%{javalibdir}/jnet.jar -Djsse.jar=%{javalibdir}/jsse.jar -Dxerces.jar=%{javalibdir}/xerces.jar -Dregexp.jar=%{javalibdir}/jakarta-regexp-1.1.jar -Dservletapi.home=$TCRPMDIR/dist/servletapi"

sh $ANT_HOME/bin/ant clean
sh $ANT_HOME/bin/ant  
sh $ANT_HOME/bin/ant dist

%install
mkdir -p $RPM_BUILD_ROOT%{bindir}
mkdir -p $RPM_BUILD_ROOT%{confdir}
mkdir -p $RPM_BUILD_ROOT%{appdir}
mkdir -p $RPM_BUILD_ROOT%{workdir}
mkdir -p $RPM_BUILD_ROOT%{manualdir}/catalina
mkdir -p $RPM_BUILD_ROOT%{manualdir}/jasper
mkdir -p $RPM_BUILD_ROOT%{manualdir}/servletapi
mkdir -p $RPM_BUILD_ROOT%{libdir}
mkdir -p $RPM_BUILD_ROOT%{logdir}
mkdir -p $RPM_BUILD_ROOT%{srvdir}
mkdir -p $RPM_BUILD_ROOT%{bxxdir}
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/usr/bin
perl -pi -e 's|8080|8180|g' dist/tomcat-4.0/conf/server.xml
perl -pi -e 's|8081|8181|g' dist/tomcat-4.0/conf/server.xml
perl -pi -e 's|8443|8543|g' dist/tomcat-4.0/conf/server.xml

cp -rf  dist/servletapi/docs/api/* 	 		$RPM_BUILD_ROOT%{manualdir}/servletapi
#cp -rf  dist/tomcat-4.0/src/*				$RPM_BUILD_ROOT%{manualdir}
cp -rf  dist/tomcat-4.0/src/catalina/docs	$RPM_BUILD_ROOT%{manualdir}
cp -rf  build/catalina/javadoc/*	 		$RPM_BUILD_ROOT%{manualdir}/catalina
cp -rf  build/jasper/javadoc/* 				$RPM_BUILD_ROOT%{manualdir}/jasper
cp -rf  dist/tomcat-4.0/lib/*     	  		$RPM_BUILD_ROOT%{libdir}
install dist/tomcat-4.0/conf/*    	  		$RPM_BUILD_ROOT%{confdir}
# here are only deployed webapps 
#install dist/tomcat-4.0/webapps/* 	 		$RPM_BUILD_ROOT%{appdir}
# deployed and manager ;-)
install dist/webapps/* 	 					$RPM_BUILD_ROOT%{appdir}
install dist/tomcat-4.0/bin/jspc.sh   		$RPM_BUILD_ROOT%{bindir}/jspc4
install dist/tomcat-4.0/bin/jasper.sh 		$RPM_BUILD_ROOT%{bindir}/jasper
install dist/tomcat-4.0/bin/catalina.sh	 	$RPM_BUILD_ROOT%{bindir}/%{tcname}
install dist/tomcat-4.0/bin/*.jar			$RPM_BUILD_ROOT%{bxxdir}	
install dist/tomcat-4.0/server/*.jar		$RPM_BUILD_ROOT%{srvdir}	
install jmxri.jar							$RPM_BUILD_ROOT%{srvdir}	

# sysv init and logging
install %{SOURCE5} .
install %{SOURCE6} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{tcname}
install %{SOURCE7} $RPM_BUILD_ROOT%{confdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
echo ""
echo ""
echo "Don't forget to set JAVA_HOME in /etc/rc.d/init.d/%{tcname}"
echo "to your JDK/JRE directory since we didn't have these info"
echo "at boot time."
echo "As supplied we assume you're using IBM JDK 1.3.0"
echo ""

/sbin/chkconfig --add %{tcname}

%preun
if [ $1 = 0 ]; then
    if [ -f /var/lock/subsys/%{tcname} ]; then
        /etc/rc.d/init.d/%{tcname} stop
    fi
    if [ -f /etc/rc.d/init.d/%{tcname} ]; then
        /sbin/chkconfig --del %{tcname}
    fi
fi

%files
%defattr(644 root root 755)
%attr(755,root,root)      %dir 				 	%{libdir}
%attr(755,root,root)      %dir 				 	%{bindir}
%attr(755,root,root)      %dir 				 	%{confdir}
%attr(755,root,root)  	  %dir 				 	%{appdir}
%attr(755,nobody,nobody)  %dir 			 		%{workdir}
%attr(755,nobody,nobody)  %dir 			 		%{logdir}
%attr(755,nobody,nobody)  %dir 			 		%{srvdir}
%attr(755,nobody,nobody)  %dir 			 		%{bxxdir}
%attr( - ,root,root)       					 	%{bindir}/*
%attr( - ,root,root) 	  %config(noreplace) 	%{confdir}/*
%attr(755,root,root)  	  %config 		 		/etc/rc.d/init.d/*
%attr(644,root,root)       				 		%{libdir}/*
%attr(644,root,root)       				 		%{appdir}/*
%attr(644,root,root)       				 		%{srvdir}/*
%attr(644,root,root)       				 		%{bxxdir}/*
%attr( - ,root,root)  	  %doc 			 		TOMCAT4.README.RPM %{packname}-src/{LICENSE,README*,RELE*,NEW*}

%files manual
%defattr(644 root root 755)
%attr( - ,root,root)                	 		%{manualdir}


%changelog
* Thu Nov 02 2000 Henri Gomez <hgomez@slib.fr>
- tomcat-v4.0m4

* Tue Oct 24 2000 Henri Gomez <hgomez@slib.fr>
- tomcat-v4.0m3 RPM Release 2
- corrected jars included 
- we assume you've installed jsse jars in /usr/share/java
- renamed tomcat4-doc to tomcat4-manual (follow apache RPM naming)
- RH 7.0 changes location of docdir and DocumentRoot. The spec file is modified
  to place manual in right place when rebuilded under RH 6.x or RH 7.0
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5
- build CLASSPATH=

* Thu Oct 19 2000 Henri Gomez <hgomez@slib.fr>
- tomcat-v4.0m3

* Tue Oct 17 2000 Henri Gomez <hgomez@slib.fr>
- tomcat-v4.0m2 RPM Release 2
- follow Debian policy about java stuff, libs in /usr/share/java,
  executable in /usr/bin, apps datas in %{homedir}
- prepare transition to RH 7.0 new document root (/var/www)
- build CLASSPATH=/usr/share/java/jsse.jar:/usr/share/java/jcert.jar:/usr/share/java/jnet.jar

* Thu Oct 12 2000 Henri Gomez <hgomez@slib.fr>
- v4.0-m2 
- to allow tomcat 3.x and tomcat 4.x coexistence, the RPM is named tomcat4.
  It start at version 4.0 and all datas will goes in /home/tomcat4.
- tomcat 4.0 need ant post 1.1, xerces 1.2.0, jsse 1.0.1 (min) and jmx.
  The RPM include ant post 1.1 (for build) and jmx (jmxri.jar for build/run) .
  I couldn't include JSSE stuff so you must download JSSE from java.sun.com.
  Next install jcert.jar, jnet.jar and jsse.jar in BOTH
  /usr/lib/java AND JAVA_HOME/jre/lib/ext
- TC 4.0 HTTP 1.1 connector moved from port 8080 to 8180 and
  from port 8081 to 8181 for HTTP 1.0 connector 
  (TC 3.x allready listen on 8080/8081)
 
* Sat Oct 07 2000 Henri Gomez <hgomez@slib.fr>
- v4.0-m1
- RPM never released

* Fri Oct 06 2000 Henri Gomez <hgomez@slib.fr>
- RPM release 2
- tomcat is now installed on /home/tomcat instead of
  /opt/tomcat since /opt is mounted read-only on
  many systems <summer@os2.ami.com.au>
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar
- correct stuff in spec file (copyright, group...)

* Mon Sep 25 2000 Henri Gomez <hgomez@slib.fr>
- v3.2-beta-5 RPM
- detect jikes and use it to rebuild (yep 10 times faster).
- patched incorrect version number
- rebuilded with jikes 1.12 (and jsse 1.0.2).
